--[[ Postal Express: Mouse Shortcuts for Mail ]]--
--shift-click to take item/money from mail
--ctrl-click to return mail
--alt-click to add item to SendMailFrame

Postal_Express = AceLibrary("AceAddon-2.0"):new("AceHook-2.1")
local lib = AceLibrary("PostalLib-1.0")

function Postal_Express:OnEnable()
 self:Hook("InboxFrame_OnClick", true)
 self:SecureHook(GameTooltip, "SetInboxItem")
 self:Hook("ContainerFrameItemButton_OnModifiedClick", true)
end

-- Ctrl-Click and Shift-Clicks Shortcuts for Mail, based on ExpressMail by Tekkub
function Postal_Express:SetInboxItem(tooltip, index)
  local _, _, _, _, money, COD, _, hasItem, _, wasReturned, _, canReply = GetInboxHeaderInfo(index)
  if money > 0 or COD > 0 or hasItem then tooltip:AddLine("Shift - Take Item") end
  if not wasReturned and canReply then tooltip:AddLine("Ctrl - Return Item") end
end

function Postal_Express:InboxFrame_OnClick(index)
  if IsShiftKeyDown() then
    lib:PurgeMail(index, 1)
    return
  elseif IsControlKeyDown() then 
    lib:ReturnMail(index)
    return
  else
    self.hooks["InboxFrame_OnClick"](index)
  end
end

function Postal_Express:ContainerFrameItemButton_OnModifiedClick(...)
  if  (...) == "LeftButton" and IsAltKeyDown() and SendMailFrame:IsVisible() and not CursorHasItem() then
    local bag, slot = this:GetParent():GetID(), this:GetID()
    local texture, count = GetContainerItemInfo(bag, slot)
    PickupContainerItem(bag, slot)
    ClickSendMailItemButton()
    local _, smf_texture, smf_count = GetSendMailItem()
    if SendMailNameEditBox:GetText() and texture == smf_texture and count == smf_count then
       SendMailFrame_SendMail()
    end
    return
  end
  self.hooks["ContainerFrameItemButton_OnModifiedClick"](...)
end
